<?php
/**
 * Creating warehouse database table on plugin activate
 * @package     Woocommerce Purolator Small
 * @author      <https://eniture.com/>
 * @copyright   Copyright (c) 2017, Eniture
 */
    if ( ! defined( 'ABSPATH' ) ) {
	exit; 
    }
    
    /**
     * Create warehouse database table
     */

    function create_purolator_small_wh_db() {
        global $wpdb;
        $warehouse_table = $wpdb->prefix . "warehouse";
            $origin = 'CREATE TABLE IF NOT EXISTS ' . $warehouse_table . '(
                        id mediumint(9) NOT NULL AUTO_INCREMENT,
                        city varchar(200) NOT NULL,
                        state varchar(200) NOT NULL,
                        zip varchar(200) NOT NULL,
                        country varchar(200) NOT NULL,
                        location varchar(200) NOT NULL,
                        nickname varchar(200) NOT NULL,
                        PRIMARY KEY  (id) )';
            dbDelta( $origin );
            en_pur_sml_add_order_details_table_function();
            add_option( 'purolator_small_db_version', '1.0' );
    }
    
        /**
 * Upgrade the DB data.
 * @global $wpdb DB class object
 */
function en_pur_sml_add_order_details_table_function() {
    
    global $wpdb;
    $order_details_table = $wpdb->prefix . "enit_order_details";
    $origin = 'CREATE TABLE IF NOT EXISTS ' . $order_details_table . '(
            id int(11) NOT NULL AUTO_INCREMENT,
            service_id varchar(300) NOT NULL,
            app_id varchar(300) NOT NULL,
            order_id varchar(300) NOT NULL,
            data longtext NOT NULL,
            plugin_name text NOT NULL,
            PRIMARY KEY  (id) )';
    dbDelta($origin);
}

    /**
     * Create plugin option
     */
    
    function create_purolator_small_option() {
        $eniture_plugins = get_option( 'EN_Plugins' );
        if( ! $eniture_plugins ) {
            add_option( 'EN_Plugins', json_encode( array ( 'purolator_small' ) ) );
        } else {
            $plugins_array = json_decode( $eniture_plugins );
            if( ! in_array( 'purolator_small', $plugins_array ) ) {
                array_push( $plugins_array, 'purolator_small' );
                update_option( 'EN_Plugins', json_encode( $plugins_array ));
            }
        }
    }