<?php
/**
 * Carrier Service
 * @package     Woocommerce Purolator Small
 * @author      <https://eniture.com/>
 * @copyright   Copyright (c) 2017, Eniture
 */
if (!defined('ABSPATH')) {
    exit;
}

/**
 * Get Quotes For purolator Small
 */

class purolator_Get_Shipping_Quotes {
    /** Global Variable */ public $purolator_sm_errors = array();
    /** Global Variable */ public $no_services_select = array();
    public $hazardous_status;
    
    /**
     * Array For Getting Quotes
     * @param $packages
     * @param $content
     */

    function purolator_Small_shipping_array($packages, $content) {
        $shipping_package_obj = new purolator_Small_Shipping_Get_Package();
        $itemTypeVal = "";
        $post_data = array();

        $residential = "";
        $destinationAddressPuroSmall = $this->destinationAddressPuroSmall();

        $exceedWeight = get_option('wc_settings_wwe_return_LTL_quotes');

        ( get_option('purolator_small_quote_as_residential_delivery') == 'yes' ) ? $residential = 'on' : '';
        $Pweight = 0;
        $findLtl = 0;
        if(isset($packages) && !empty($packages))
        {    
            foreach ($packages as $package) {
            if (!( $exceedWeight == 'yes' && $Pweight > 150)) {
                $lineItem = array();
                foreach ($package['items'] as $item) {
                    $Pweight = $item['productWeight'];
                    $lineItem[$item['productId']] = array(
                       'lineItemWeight' => $item['productWeight'],
                       'piecesOfLineItem' => $item['productQty'],
                       'lineItemHeight' => $item['productHeight'],
                       'lineItemWidth' => $item['productWidth'],
                       'lineItemLength' => $item['productLength'],
                   );
                }

                if ($destinationAddressPuroSmall['country'] == 'CA') {
                    $serviceId = 'PurolatorGround';
                } else if ($destinationAddressPuroSmall['country'] == 'US') {
                    $serviceId = 'PurolatorGroundU.S.';
                } else {
                    $serviceId = 'PurolatorExpressInternational';
                }
                
                $aPluginVersions = $this->purolator_small_wc_version_number();
                
                $domain = $_SERVER['SERVER_NAME'];
                
                $post_data[$package['origin']['zip']] = array(
                    'plateform'         => 'WordPress',
                    'plugin_version'        => $aPluginVersions["purolator_small_plugin_version"],
                    'wordpress_version'     => get_bloginfo('version'),
                    'woocommerce_version'   => $aPluginVersions["woocommerce_plugin_version"],
                    'licence_key'       => get_option('purolator_small_licence_key'),
                    'sever_name'        => $this->purolator_small_parse_url($domain), 

                    'carrierName'       => 'purolator',
                    'carrier_mode'      => 'pro',

                    'productionKey'     => get_option('purolator_small_pro_key'), 
                    'productionPass'    => get_option('purolator_small_pro_key_pass'),
                    'registeredAccount' => get_option('purolator_small_registered_account_number'),

                    'billingAccount'    => get_option('purolator_small_billing_account_number'),

                    'QuoteType'         => 'Domestic',
                    'accessLevel'       => 'pro',

                    'senderCity'        => $package['origin']['city'],
                    'senderState'       => $package['origin']['state'],
                    'senderZip'         => $package['origin']['zip'],
                    'senderCountryCode' => $package['origin']['country'],

                    'receiverCity'      => $destinationAddressPuroSmall['city'],
                    'receiverState'     => $destinationAddressPuroSmall['state'],
                    'receiverZip'       => $destinationAddressPuroSmall['zip'],
                    'receiverCountryCode' => $destinationAddressPuroSmall['country'],

                    'accessorial'       => array(),
                    'ServiceID'         => $serviceId,
                    'hazardousMaterial' => ( $package['hazardousMaterial'] == 'yes' ) ? 1 : 0,
                    
                    'commdityDetails'   => array(
                        'handlingUnitDetails' => $lineItem
                    ),
                );
            }
             $post_data = apply_filters(
                'enit_box_sizes_post_array_filter', $post_data, $package,
                $package['origin']['zip']
            );
        }
       
        }
       
        return $post_data;
    }

    /**
     * URL Rewriting
     * @param $domain
     * @return url
     */
    function purolator_small_parse_url($domain) {
        $domain = trim($domain);
        $parsed = parse_url($domain);
        if (empty($parsed['scheme'])) {
            $domain = 'http://' . ltrim($domain, '/');
        }
        $parse = parse_url($domain);
        $refinded_domain_name = $parse['host'];
        $domain_array = explode('.', $refinded_domain_name);
        if (in_array('www', $domain_array)) {
            $key = array_search('www', $domain_array);
            unset($domain_array[$key]);
            $refinded_domain_name = implode($domain_array, '.');
        }
        return $refinded_domain_name;
    }
    
    /**
     * destinationAddressFedexSmall
     * @return array type
     */
    function destinationAddressPuroSmall()
    {
        $purolator_small_woo_obj = new purolator_Small_Woo_Update_Changes();
        $freight_zipcode = (strlen(WC()->customer->get_shipping_postcode()) > 0) ? WC()->customer->get_shipping_postcode() : $purolator_small_woo_obj->purolator_small_postcode();
        $freight_state   = (strlen(WC()->customer->get_shipping_state()) > 0)    ? WC()->customer->get_shipping_state()    : $purolator_small_woo_obj->purolator_small_getState();
        $freight_country = (strlen(WC()->customer->get_shipping_country()) > 0)  ? WC()->customer->get_shipping_country()  : $purolator_small_woo_obj->purolator_small_getCountry();
        $freight_city    = (strlen(WC()->customer->get_shipping_city()) > 0)     ? WC()->customer->get_shipping_city()     : $purolator_small_woo_obj->purolator_small_getCity();
        return array(
            'city'      => $freight_city , 
            'state'     => $freight_state , 
            'zip'       => $freight_zipcode , 
            'country'   => $freight_country
        );
    }

    /**
     * Get Nearest Address If Multiple Warehouses
     * @param $warehous_list
     * @param $receiverZipCode
     * @return array
     */
    function purolator_Small_multi_warehouse($warehous_list, $receiverZipCode) {
        if (count($warehous_list) == 1) {
            $warehous_list = reset($warehous_list);
            return $this->purolator_small_origin_array($warehous_list);
        }
        
        $purolator_Small_distance_request = new Get_purolator_small_distance();
        $accessLevel = "MultiDistance";
        $response_json                 = $purolator_Small_distance_request->purolator_small_address($warehous_list, $accessLevel, $this->destinationAddressPuroSmall());

        $response_json = json_decode($response_json);
        return $this->purolator_small_origin_array( $response_json->origin_with_min_dist );
    }

    /**
     * Create Origin Array
     * @param $origin
     * @return array
     */
    function purolator_small_origin_array($origin) {
        $zip = $origin->zip;
        $city = $origin->city;
        $state = $origin->state;
        $country = ($origin->country == "CN") ? "CA" : $origin->country;
        $location = $origin->location;
        $locationId = $origin->id;
        return array('locationId' => $locationId, 'zip' => $zip, 'city' => $city, 'state' => $state, 'location' => $location, 'country' => $country);
    }

    /*
     * 
      @ param : Requeted Data Array
     * 
      @ return Quotes Json
     */
    /**
     * Get purolator Small Web Quotes
     * @param $request_data
     */
    function purolator_small_get_quotes($request_data) {

        if (is_array($request_data) && count($request_data) > 0) {

            $purolator_small_curl_obj = new Purolator_Small_Curl_Request();
            $output   = $purolator_small_curl_obj->purolator_small_get_curl_response('https://eniture.com/ws/index.php', $request_data);

            return json_decode($output);
        }
    }

    /**
     * Get Shipping Array For Single Shipment
     * @param $result
     */
    function parse_purolator_small_output($result) {

        $all_services_array = array();
        $estimatedTransitDays = "";
        $serviceID = "";
        $totalPrice = "";
        $hazardous_fee = 0;

        if (isset($result->q) ) {

            $quotesArr = $result->q;
                    
            $handling_fee   = get_option('purolator_small_hand_fee_mark_up');
            $hazardous_fee  = get_option('purolator_small_hazardous_fee');
            
            $active_services = $this->service_options_array();

                foreach ($quotesArr as $key => $service) {
                    
                    $estimatedTransitDays = $service->transitTime;
                    
                    if ( isset( $service->serviceType ) && in_array($service->serviceType, $active_services)) {
                                             
                        $serviceID = $service->serviceType;
                        $totalPrice = $service->totalNetCharge->Amount;
                        if ($handling_fee != "") {
                            $grand_total = $this->calculate_handeling_fee($handling_fee, $totalPrice);
                        } else {
                            $grand_total = $totalPrice;
                        }
                        
                        if ( $result->hazardousMaterial == 1 ) {
                            $grand_total = ( !empty($hazardous_fee) ) ? $hazardous_fee + $grand_total : $grand_total;
                        } 

                        $service_title = $this->purolatorServiceNames($serviceID);

                        $all_services_array[] = array(
                            'ServiceID'             => $serviceID,
                            'TotalPrice'            => $grand_total,
                            'EstimatedTransitDays'  => $estimatedTransitDays,
                            'title'                 => $service_title
                        );                       
                    }
                }
            
            $price_sorted_key = array();
            foreach ($all_services_array as $key => $cost_carrier) {
                $price_sorted_key[$key] = $cost_carrier['TotalPrice'];
            }
            array_multisort($price_sorted_key, SORT_ASC, $all_services_array);

            return $all_services_array;
        }
    }

    /**
     * Get Shipping Array For Multiple Shipment
     * @param type $quotes
     */
    function purolator_small_quotes_grouping($quotes) {

        $totalPrice = 0;
        $grand_total = 0;
        $hazardous_fee = 0;
        $active_services = $this->service_options_array();
        $handling_fee  = get_option('purolator_small_hand_fee_mark_up');
        $hazardous_fee = get_option('purolator_small_hazardous_fee');

        foreach ($quotes as $zip => $result) {
            if ( !empty( $result->q ) && !empty( $active_services ) ) {

                $allServices = array();
                $quotesArr = $result->q;
                
                foreach ($quotesArr as $val) {
                    if (in_array($val->serviceType, $active_services)) {

                        $serviceID = $val->serviceType;
                        $cost = $val->totalNetCharge->Amount;

                        if ($handling_fee != "") {
                            $totalPrice = $this->calculate_handeling_fee($handling_fee, $cost);
                        } else {
                            $totalPrice = $cost;
                        }
                        
                        if ( $result->hazardousMaterial == 1 ) {
                            $totalPrice = ( !empty($hazardous_fee) ) ? $hazardous_fee + $totalPrice : $totalPrice;
                        } 

                        
                        $service_title = $this->purolatorServiceNames($serviceID);

                        if ($totalPrice > 0) {
                            $allServices[] = array(
                                'serivceID'     => $serviceID,
                                'title'         => $service_title,
                                'totalPrice'    => $totalPrice
                            );
                        }
                    }
                }
                
                $price_sorted_key = array();

                foreach ($allServices as $key => $cost_carrier) {
                    $price_sorted_key[$key] = $cost_carrier['totalPrice'];
                }
                array_multisort($price_sorted_key, SORT_ASC, $allServices);
                $allServices = reset($allServices);
                $minPrices[$zip] = $allServices;
                (count($allServices) > 1 ) ? $grand_total += $allServices['totalPrice'] : $this->no_services_select = 'No Service Selected';

                
            } else {
                $minPrices[$zip] =  array(
                            'serivceID' => 'no_quotes',
                            'title' => '',
                            'totalPrice' => 0.00
                        );
                $this->purolator_sm_errors = 'no quotes return';
                continue;
            }
        }

        if (count($active_services) > 0) {
            
            return array('cost' => $grand_total, 'minPrices' => $minPrices);
        }
    }

    /**
     * Calculate Handeling Fee For Each Shipment
     * @param $handeling_fee
     * @param $total
     */
    function calculate_handeling_fee($handeling_fee, $total) {
        $grandTotal = 0;
        if (floatval($handeling_fee)) {
            $pos = strpos($handeling_fee, '%');
            if ($pos > 0) {
                $rest = substr($handeling_fee, $pos);
                $exp = explode($rest, $handeling_fee);
                $get = $exp[0];
                $percnt = $get / 100 * $total;
                $grandTotal += $total + $percnt;
            } else {
                $grandTotal += $total + $handeling_fee;
            }
        } else {
            $grandTotal += $total;
        }
        return $grandTotal;
    }

    /**
     * purolator Selected Services From Admin Configuration
     * @return string
     */
    function service_options_array() {
        $active_services = array();

        if (get_option('purolator_small_express_9') == 'yes') {
            $active_services[] = 'PurolatorExpress9AM';
        }

        if (get_option('purolator_small_express_10') == 'yes') {
            $active_services[] = 'PurolatorExpress10:30AM';
        }

        if (get_option('purolator_small_express') == 'yes') {
            $active_services[] = 'PurolatorExpress';
        }

        if (get_option('purolator_small_ground') == 'yes') {
            $active_services[] = 'PurolatorGround';
        }
        
        if (get_option('purolator_small_ground_us') == 'yes') {
            $active_services[] = 'PurolatorGroundU.S.';
        }

        if (get_option('purolator_small_express_us') == 'yes') {
            $active_services[] = 'PurolatorExpressU.S.';
        }
        if (get_option('purolator_small_express_us_10am') == 'yes') {
            $active_services[] = 'PurolatorExpressU.S.10:30AM';
        }

        if (get_option('purolator_small_express_us_9am') == 'yes') {
            $active_services[] = 'PurolatorExpressU.S. 9AM';
        }

        if (get_option('purolator_small_express_inter') == 'yes') {
            $active_services[] = 'PurolatorExpressInternational';
        }

        return $active_services;
    }
    
    /**
     * Get Service Name
     * @param $rawService
     * @return string
     */
    function purolatorServiceNames($rawService){
        switch ($rawService) {
            case 'PurolatorExpress':
                $newName = 'Purolator Express';
                break;
            case 'PurolatorGround':
                $newName = 'Purolator Ground';
                break;
            case 'PurolatorGroundU.S.':
                $newName = 'Purolator Ground U.S';
                break;
            case 'PurolatorExpressU.S.':
                $newName = 'Purolator Express U.S';
                break;
            case 'PurolatorExpressU.S.10:30AM':
                $newName = 'Purolator Express U.S 10:30AM';
                break;
            case 'PurolatorExpress10:30AM':
                $newName = 'Purolator Express 10:30AM';
                break;
            case 'PurolatorExpress9AM':
                $newName = 'Purolator Express 9AM';
                break;
            case 'PuroloatorExpressU.S.9AM':
                $newName = 'Purolator Express U.S 9AM';
                break;
            default:
                $newName = preg_replace('/([A-Z])/', ' $1', $rawService);
                break;
        }
        return $newName;
    }

    /**
     * Get Names Of purolator Selected Services (DOMESTIC) From Admin Configuration
     * @param $rawService
     */
    function purolatorSmallDomesticServiceNames($rawService) {
        switch ($rawService) {
            case 'PurolatorExpress9AM':
                $newName = 'purolator express 9AM';
                break;
            case 'purolator_small_express_10':
                $newName = 'purolator express 10:30AM';
                break;
            case 'PurolatorExpress':
                $newName = 'purolator express';
                break;
            case 'purolator_small_ground':
                $newName = 'purolator ground';
                break;

            default:
                $newName = preg_replace('/([A-Z])/', ' $1', $rawService);
                break;
        }

        return $newName;
    }

    /**
     * purolator Get Shipment Rated Array
     * @param $locationGroups
     */
    function RatedShipmentDetails($locationGroups) {
        $rates_option = get_option('wc_pulish_negotiate_purolator_small');
        ( $rates_option == 'negotiated' ) ? $searchword = 'PAYOR_ACCOUNT' : $searchword = 'PAYOR_LIST';
        $allLocations = array_filter($locationGroups, function( $var ) use ( $searchword ) {
            return preg_match("/^$searchword/", $var->ShipmentRateDetail->RateType);
        });
        return $allLocations;
    }

    /**
     * woocomerce version 
     */    
    function purolator_small_wc_version_number() 
    {
        if (!function_exists('get_plugins'))
            require_once( ABSPATH . 'wp-admin/includes/plugin.php' );
        
        $plugin_folder                  = get_plugins('/' . 'woocommerce');
        $plugin_file                    = 'woocommerce.php';
        $purolator_small_plugin_folders = get_plugins('/' . 'small-package-quotes-purolator-edition');
        $purolator_small_plugin_files   = 'small-package-quotes-purolator-edition.php';
        $wc_plugin                      = (isset($plugin_folder[$plugin_file]['Version'])) ? $plugin_folder[$plugin_file]['Version'] : "";
        $purolator_small_plugin         = (isset($purolator_small_plugin_folders[$purolator_small_plugin_files]['Version']))  ? $purolator_small_plugin_folders[$purolator_small_plugin_files]['Version'] : "";

        $pluginVersions = array(
            "woocommerce_plugin_version"      => $wc_plugin,
            "purolator_small_plugin_version"  => $purolator_small_plugin
        );

        return $pluginVersions;
    }
        
}
