<?php
/**
 * Dropship Template
 * @package     Woocommerce Purolator Small
 * @author      <https://eniture.com/>
 * @copyright   Copyright (c) 2017, Eniture
 */
    if ( ! defined( 'ABSPATH' ) ) {
        exit; 
    }
    
    /**
     * Get Drop Ship List From Warehouse Table
     */

    $dropship_list = $wpdb->get_results(
        "SELECT id, city, state, zip, country, location, nickname
        FROM ".$wpdb->prefix."warehouse WHERE location = 'dropship'"
    );
?>
<script type="text/javascript">
    jQuery( document ).ready( function () {
        jQuery( '.hide_drop_val' ).click( function () {
            
            /*
             * Hide Values Upon Popup Open
             */
            
            
            jQuery( '.city_input' ).show();
            jQuery( '.not_allowed, .city_select, .already_exist, .dropship_invalid_input_message, .wrng_credential, .purolator_small_zip_validation_err, .purolator_small_city_validation_err, .purolator_small_state_validation_err, .purolator_small_country_validation_err' ).hide();
            jQuery( '#edit_dropship_form_id, #purolator_small_dropship_zip, #purolator_small_dropship_state, #purolator_small_dropship_country, #purolator_small_dropship_city, #purolator_small_dropship_nickname' ).val( '' );
            jQuery( '#purolator_small_origin_city' ).css( 'background', 'none' );
            jQuery( '.purolator_small_multi_state' ).empty();
//            jQuery( '#purolator_small_dropship_city' ).css( 'background', 'none' );
        });
      
        
        /*
         * Set Focus On First Input Field
         */
        
        jQuery( '.purolator_small_add_dropship_btn' ).click( function () {
            setTimeout( function (){
                if( jQuery( '.ds_popup' ).is( ':visible' ) ) {
                  jQuery( '.ds_input > input' ).eq( 0 ).focus();
                }
            }, 500 );
        });
      
        
        /*
         * Get Address Trough Api Call
         */
        
        jQuery( "#purolator_small_dropship_zip" ).on( 'change', function () {
        if ( jQuery( "#purolator_small_dropship_zip" ).val() == '') {
            return false;
        }
        
        jQuery( '.city_select_css, #purolator_small_dropship_city, #purolator_small_dropship_state, #purolator_small_dropship_country' ).addClass( 'purolator_small_test_conn_prosessing' );
        
        var postForm = {
            'action'        : 'purolator_small_get_address',
            'origin_zip'    : jQuery( '#purolator_small_dropship_zip' ).val(),
        };

        jQuery.ajax({
            type        : 'POST', 
            url         : ajaxurl, 
            data        : postForm, 
            dataType    : 'json',
            beforeSend: function () 
            {
                jQuery( '.purolator_small_zip_validation_err, .purolator_small_city_validation_err, .purolator_small_state_validation_err, .purolator_small_country_validation_err' ).hide();
            },
            success: function (data) 
            {
                if( data ){
                    if( data.state && data.country == 'CA' ){
                        if (data.postcode_localities == 1) {
                            jQuery( '.city_select' ).show();
                            jQuery( '#dropship_actname' ).replaceWith( data.city_option );
                            jQuery( '.purolator_small_multi_state' ).replaceWith( data.city_option );
                            jQuery( '#purolator_small_dropship_state' ).val( data.state );
                            jQuery( '#purolator_small_dropship_country' ).val( data.country );
                            jQuery( '.city-multiselect' ).change( function(){
                                setCity(this);
                            });
                            jQuery( '#purolator_small_dropship_city' ).val( data.first_city );
                            jQuery( '.city_select_css, #purolator_small_dropship_city, #purolator_small_dropship_state, #purolator_small_dropship_country' ).removeClass( 'purolator_small_test_conn_prosessing' );                            
                            jQuery( '.city_input' ).hide();
                        }else{
                            jQuery( '.city_input' ).show();
                            jQuery( '#_city' ).removeAttr('value');
                            jQuery( '.city_select' ).hide();
                            jQuery( '#purolator_small_dropship_city' ).val( data.city );
                            jQuery( '#purolator_small_dropship_state' ).val( data.state );
                            jQuery( '#purolator_small_dropship_country' ).val( data.country );
                            jQuery( '#purolator_small_dropship_city, #purolator_small_dropship_state, #purolator_small_dropship_country' ).removeClass( 'purolator_small_test_conn_prosessing' );     
                        }
                    }else if( data.result === 'false' ){
                        jQuery( '#purolator_small_dropship_city, #purolator_small_dropship_state, #purolator_small_dropship_country' ).removeClass( 'purolator_small_test_conn_prosessing' );       
                    }else if( data.apiResp === 'apiErr' ){
                        jQuery( '.wrng_credential' ).show('slow');
                        jQuery( '#purolator_small_dropship_city, #purolator_small_dropship_state, #purolator_small_dropship_country' ).removeClass( 'purolator_small_test_conn_prosessing' );      
                        setTimeout(function () {
                            jQuery('.wrng_credential').hide('slow');
                        }, 5000);
                    }else{
                        jQuery( '.not_allowed' ).show('slow');
                        jQuery( '#purolator_small_dropship_city, #purolator_small_dropship_state, #purolator_small_dropship_country' ).removeClass( 'purolator_small_test_conn_prosessing' );     
                        setTimeout(function () {
                            jQuery('.not_allowed').hide('slow');
                        }, 5000);
                    }
                }
            },
        }); 
            return false;
        });
    });
  
    function setCity( e ){
      var city = jQuery( e ).val();
      jQuery( '#purolator_small_dropship_city' ).val( city );
    }
    jQuery( function() {
        jQuery( 'input.alphaonly' ).keyup( function() {
            if ( this.value.match( /[^a-zA-Z ]/g ) ) {
                this.value = this.value.replace( /[^a-zA-Z ]/g, '' );
            }
        });
    });
</script>
    <a href="#purolator_small_delete_dropship_btn" class="purolator_small_delete_dropship_btn hide_drop_val"></a>
    
    <div id="purolator_small_delete_dropship_btn" class="purolator_small_warehouse_overlay">
        <div class="purolator_small_add_warehouse_popup">
            <h2 class="del_hdng">
                Warning!
            </h2>
            
            <p class="delete_p">
                Warning! If you delete this location, Drop ship location settings will be disable against products if any.
            </p>
            
            <div class="del_btns">
                <a href="#" class="purolator_small_cancel_delete">Cancel</a>
                <a href="#" class="purolator_small_confirm_delete">OK</a>
            </div>
        </div>
    </div>
    
    <h1>
        Drop ships
    </h1>
    
    <br>
    
    <a href="#add_dropship_btn" title="Add Drop ship" class="purolator_small_add_dropship_btn hide_drop_val">
        Add
    </a>
    
    <br>
    
    <div class="warehouse_text">
        <p>
            Locations that inventory specific items that are drop shipped to the destination. Use the product's settings page to identify it as a drop shipped item and its associated drop ship location. Orders that include drop shipped items will display a single figure for the shipping rate estimate that is equal to the sum of the cheapest option of each shipment required to fulfill the order.
        </p>
    </div>
    
    <div id="message" class="updated inline dropship_created">
        <p>
            <strong>
                Success! New drop ship added successfully.
            </strong>
        </p>
    </div>
    
    <div id="message" class="updated inline dropship_updated">
        <p>
            <strong>
                Success! Drop ship updated successfully.
            </strong>
        </p>
    </div>
    
    <div id="message" class="updated inline dropship_deleted">
        <p>
            <strong>
                Success! Drop ship deleted successfully.
            </strong>
        </p>
    </div>
    
    <table class="purolator_small_dropship_list" id="append_dropship">
        <thead>
            <tr>
                <th class="purolator_small_dropship_list_heading">
                    Nickname
                </th>
                
                <th class="purolator_small_dropship_list_heading">
                    City
                </th>
                
                <th class="purolator_small_dropship_list_heading">
                    State
                </th>
                
                <th class="purolator_small_dropship_list_heading">
                    Zip
                </th>
                
                <th class="purolator_small_dropship_list_heading">
                    Country
                </th>
                
                <th class="purolator_small_dropship_list_heading">
                    Action
                </th>
            </tr>
        </thead>
        <tbody>
        <?php
            if ( count( $dropship_list ) > 0 ) {
                foreach ( $dropship_list as $list ) 
                {
        ?>
            <tr id="row_<?php echo ( isset( $list->id ) ) ? esc_attr( $list->id ) : ''; ?>">
                <td class="purolator_small_dropship_list_data">
                    <?php echo ( isset( $list->nickname ) ) ? esc_attr( $list->nickname ) : ''; ?>
                </td>
                
                <td class="purolator_small_dropship_list_data">
                    <?php echo ( isset( $list->city ) ) ? esc_attr( $list->city ) : ''; ?>
                </td>
                
                <td class="purolator_small_dropship_list_data">
                    <?php echo ( isset( $list->state ) ) ? esc_attr( $list->state ) : ''; ?>
                </td>
                
                <td class="purolator_small_dropship_list_data">
                    <?php echo ( isset( $list->zip ) ) ? esc_attr( $list->zip ) : ''; ?>
                </td>
                
                <td class="purolator_small_dropship_list_data">
                    <?php echo ( isset( $list->country ) ) ? esc_attr( $list->country ) : ''; ?>
                </td>
                
                <td class="purolator_small_dropship_list_data">
                    <a href="javascript(0)" onclick="return purolator_small_edit_dropship(<?php echo ( isset( $list->id ) ) ? esc_attr( $list->id ) : ''; ?>);"><img src="<?php echo plugins_url(); ?>/small-package-quotes-purolator-edition/asset/edit.png" title="Edit"></a>
                    <a href="javascript(0)" onclick="return purolator_small_delete_current_dropship(<?php echo ( isset( $list->id ) ) ? esc_attr( $list->id ) : ''; ?>);"><img src="<?php echo plugins_url(); ?>/small-package-quotes-purolator-edition/asset/delete.png" title="Delete"></a>
                </td>
            </tr>
        <?php   } 
            }else{ ?>
            <tr class="new_dropship_add" data-id=0></tr>
        <?php } ?>
        </tbody>
    </table>

    <!-- Add Popup for new dropship -->
    <div id="add_dropship_btn" class="purolator_small_warehouse_overlay">
        <div class="purolator_small_add_warehouse_popup ds_popup">
            <h2 class="dropship_heading">
                Drop Ship
            </h2>
            
            <a class="close" href="#">
                &times;
            </a>
            
            <div class="content">
                <div class="already_exist">
                    <strong>
                        Error!
                    </strong> Zip code already exists.
                </div>
                <div class="dropship_invalid_input_message">
                    <strong>
                        Error!
                    </strong> Invalid input data.
                </div>
                <div class="not_allowed">
                    <strong>
                        Error!
                    </strong> Please enter CA zip code.
                </div>
                
                <div class="wrng_credential">
                    <strong>
                        Error!
                    </strong> Please verify credentials at connection settings panel.
                </div>
                
                <form method="post">
                    <input type="hidden" name="edit_dropship_form_id" value="" id="edit_dropship_form_id">
                    <div class="purolator_small_add_warehouse_input ds_input">
                        <label for="purolator_small_ds_nickname">
                            Nickname
                        </label>
                        <input type="text" title="Nickname" value="" name="purolator_small_dropship_nickname" placeholder="Nickname" id="purolator_small_dropship_nickname">
                     </div>
                    
                    <div class="purolator_small_add_warehouse_input">
                        <label for="purolator_small_warehouse_zip">
                            Zip
                        </label>
                        <input type="text" value="" title="Zip" name="purolator_small_dropship_zip" placeholder="30214" id="purolator_small_dropship_zip">
                    </div>
              
                    <div class="purolator_small_add_warehouse_input city_input">
                        <label for="purolator_small_warehouse_city">
                            City
                        </label>
                        <input type="text" value="" title="City" name="purolator_small_dropship_city" placeholder="Fayetteville" id="purolator_small_dropship_city">
                    </div>
              
                    <div class="purolator_small_add_warehouse_input city_select" style="display:none;">
                        <label for="purolator_small_warehouse_city">
                            City
                        </label>
                        <select id="dropship_actname" value=""></select>
                    </div>
              
                    <div class="purolator_small_add_warehouse_input">
                        <label for="purolator_small_warehouse_state">
                            State
                        </label>
                        <input type="text" value="" title="State" maxlength="2" name="purolator_small_dropship_state" placeholder="GA" id="purolator_small_dropship_state">
                    </div>
              
                    <div class="purolator_small_add_warehouse_input">
                        <label for="purolator_small_warehouse_country">
                            Country
                        </label>
                        <input type="text" name="purolator_small_dropship_country" title="Country" maxlength="2" value="" placeholder="US" id="purolator_small_dropship_country">
                        <input type="hidden" name="purolator_small_dropship_location" value="dropship" id="purolator_small_dropship_location">
                    </div>
                    
                    <div class="purolator_small_add_warehouse_input">
                        <input type="submit" name="purolator_small_submit_dropship" value="Save" class="save_warehouse_form" onclick="return save_purolator_small_dropship();">
                    </div>
                </form>
            </div>
        </div>
    </div>
     