<?php
/**
 * Product Detaial
 * @package     Woocommerce Purolator Small
 * @author      <https://eniture.com/>
 * @copyright   Copyright (c) 2017, Eniture
 */
    if ( ! defined( 'ABSPATH' ) ) {
        exit; 
    }
    
    /**
     * Drop Ship For Shipping Section In Product Detail Page
     * @global $wpdb
     * @param $loop
     * @param $variation_data
     * @param $variation
     */
        function purolator_small_dropship($loop, $variation_data = array(), $variation = array()) {
            global $wpdb;
            $dropship_list = $wpdb->get_results("SELECT id, city, state, zip, country, location, nickname FROM ".$wpdb->prefix."warehouse WHERE location = 'dropship'");
            if(!empty($dropship_list)){

                ( isset( $variation->ID ) && $variation->ID > 0 ) ? $variationID = $variation->ID : $variationID = get_the_ID();

                /**
                 * create enable dropship checkbox.
                 */
                
                woocommerce_wp_checkbox(
                array(
                    'id'    => '_enable_dropship['.$variationID.']',
                    'label' => __('Enable drop ship location', 'woocommerce'),
                    'value' => get_post_meta( $variationID, '_enable_dropship', true ),
                    )
                );

                $attributes = array(
                        'id' => '_dropship_location['.$variationID.']',
                        'class' => 'p_ds_location',
                );

                $get_loc = maybe_unserialize(get_post_meta($variationID, '_dropship_location', true));

                $valuesArr = array();
                foreach ($dropship_list as $list) {
                    ( isset($list->nickname) && $list->nickname == '' ) ? $nickname = '' : $nickname = $list->nickname . ' - ';
                    ( isset($list->country) && $list->country == '' ) ? $country = '' : $country = '(' .$list->country. ')';
                    $location = $nickname . $list->zip . ', ' . $list->city . ', ' . $list->state .' ' . $country;
                    $finalValue['option_id'] = $list->id;
                    $finalValue['option_value'] = $list->id;
                    $finalValue['option_label'] = $location;
                    $valuesArr[] = $finalValue;
                }

                $aFields[] = array(
                        'attributes'    =>  $attributes,
                        'label'         => 'Drop ship location',
                        'value'         => $valuesArr,
                        'name'          => '_dropship_location['.$variationID.'][]',
                        'type'          =>'select',
                        'selected_value' => $get_loc,
                        'variant_id'    => $variationID
                    );

                $aFields = apply_filters('before_wwe_ltl_product_detail_fields', $aFields);

                apply_filters('En_Plugins_dropship_filter', $aFields,$get_loc, $variationID);
            }
        }
        
    /**
     * Dropship Filter
     */
    
        if( ! has_filter( 'En_Plugins_dropship_filter' ) ) {
            add_action( 'woocommerce_product_options_shipping', 'purolator_small_dropship' );
            add_action( 'woocommerce_product_after_variable_attributes', 'purolator_small_dropship', 10, 3 );
            add_filter( 'En_Plugins_dropship_filter','purolator_small_dropship_filter', 10, 3 );
        }
    /**
     * Filter Function
     * @param $aFields
     * @param $get_loc
     * @param $variationID
     */
        function purolator_small_dropship_filter( $aFields, $get_loc, $variationID ) {
            $fieldsHtml = '';
            foreach ($aFields as $key => $sField) {
                $sField = apply_filters( 'wwe_ltl_product_detail_fields', $sField );
                $fieldsHtml = purolator_small_dropship_html($sField, $fieldsHtml, $get_loc, $variationID);
            }
            $fieldsHtml = apply_filters('after_wwe_ltl_product_detail_fields', $fieldsHtml);
            echo $fieldsHtml;
        }

    /**
     * Attribute For Drop Ship Dropdown
     * @param $attributes
     * @return string
     */
        
        function purolator_small_attributes_string( $attributes ) {
            $str = '';
            foreach($attributes as $key=>$sAttribute){
                $str .= ' '.$key.' ="'.$sAttribute.'" ';                                        
            }
            return $str;
        }
    
    /**
     * Drop Ship Dropdown Select
     * @param $sField
     * @param $fieldsHtml
     * @return HTML
     */
        
        function purolator_small_dropship_html( $sField, $fieldsHtml ) {
            $str = purolator_small_attributes_string( $sField['attributes'] );

            $fieldsHtml .= '<p class="form-field _dropship_location">';
            $fieldsHtml .= '<label for="_dropship_location">'.$sField['label'].'</label>';
            if($sField['type'] == 'select'){
                $fieldsHtml .= '<select name="'.$sField['name'].'" '.$str.'>';
                if ($sField['value']) {

                    foreach ($sField['value'] as $option) {
                        $selected_option = purolator_sm_product_ds_selected_option($sField['selected_value'], $option['option_value']);
                        $fieldsHtml .= '<option value="'.esc_attr($option['option_value']).'" '.$selected_option.'>'.esc_html($option['option_label']).' </option>';
                    }
                }
                $fieldsHtml .= '</select>';
            }
            $fieldsHtml .= '</p>';
            return $fieldsHtml;
        }
    
    /**
     * Drop Ship Dropdown Selected Options
     * @param $get_loc
     * @param $option_val
     */  
        function purolator_sm_product_ds_selected_option($get_loc, $option_val){
            $selected = '';
            if(is_array($get_loc)){
                if(in_array($option_val, $get_loc)){
                    $selected =  'selected="selected"';
                }
            }else{
                $selected = selected($get_loc, $option_val, false);
            }
            return $selected;
        }
        
                
    /**
     * Purolator Small Hazardous Materials
     * Param : Loop Array, Variation Data Array, Variation  Array
     @ return hazardous List In loop on Different Variation
     */ 
        if( ! has_filter( 'En_Plugins_hazmet_filter' ) )
        {
            add_action( 'woocommerce_product_options_shipping', 'purolator_small_hazardous_materials', 30 );
            add_action( 'woocommerce_product_after_variable_attributes', 'purolator_small_hazardous_materials' , 30, 3 );
            add_filter( 'En_Plugins_hazmet_filter', 'purolator_small_hazmet_field_filter', 30, 1 );
        }
    /**
     * Check Hazardous
     * @param $hazardous
     */    
        function purolator_small_hazmet_field_filter( $hazardous ) {
            return $hazardous;
        }
    /**
     * Product Hazardouse Check
     * @global $wpdb
     * @param $loop
     * @param $variation_data
     * @param $variation
     */
        function purolator_small_hazardous_materials($loop, $variation_data = array(), $variation = array()) 
        {
            global $wpdb;
            
            ( isset( $variation->ID ) && $variation->ID > 0 ) ? $variationID = $variation->ID : $variationID = get_the_ID();

            $hazardous =  woocommerce_wp_checkbox(
                array(
                    'id'     => '_hazardousmaterials['.$variationID.']',
                    'label'  => __('Hazardous materials', 'woocommerce'),
                    'value'  => get_post_meta( $variationID, '_hazardousmaterials', true ),
                )
            );
            apply_filters( 'En_Plugins_hazmet_filter', $hazardous );
        } 
        
    /**
     * Save Product Custom Shipping Options
     */
    
        add_action( 'woocommerce_process_product_meta', 'purolator_sm_custom_product_fields_save' );  
        add_action('woocommerce_save_product_variation', 'purolator_sm_custom_product_fields_save', 10, 1);
    /**
     * Custom Field Save
     * @param $post_id
     */    
        function purolator_sm_custom_product_fields_save($post_id) 
        {

            if (isset($post_id) && $post_id>0) :

                $enable_ds = ( isset( $_POST['_enable_dropship'][$post_id] ) ? sanitize_text_field( $_POST['_enable_dropship'][$post_id] ) : "");
                $dropship_location      = array_map( 'sanitize_text_field', wp_unslash( $_POST['_dropship_location'][$post_id] ) );
                $dropship_location_val  = array_map( 'intval', $dropship_location );
                $woocommerce_hazardous  = ( isset($_POST['_hazardousmaterials'][$post_id]) ) ? sanitize_text_field( $_POST['_hazardousmaterials'][$post_id] ) : ""; 
                
                update_post_meta($post_id, '_enable_dropship', esc_attr($enable_ds));
                update_post_meta($post_id, '_hazardousmaterials', esc_attr($woocommerce_hazardous));
                
                if (isset($dropship_location)) {
                    update_post_meta($post_id, '_dropship_location', maybe_serialize($dropship_location_val));
                }

            endif;
        }