<?php
/**
 * Quote Settings
 * @package     Woocommerce Purolator Small
 * @author      <https://eniture.com/>
 * @copyright   Copyright (c) 2017, Eniture
 */
        if ( ! defined( 'ABSPATH' ) ) {
            exit; 
        }
    
        /**
         * Class For Quote Settings Tab
         */
        
            class purolator_Small_Quote_Settings {
                
                /**
                 * Quote Setting Fields
                 * @return array
                 */
                
                    function purolator_small_quote_settings_tab() {
                        
                        echo '<div class="purolator_small_quote_section">';
                        $settings = array(
                            'purolator_small_services' => array(
                                'name' => __('Purolator Services' , 'woocommerce-settings-purolator_small_quotes'),
                                'type' => 'title',
                                'desc' => '<div><p><strong>Note! The service selected will display in the cart if they are available for the origin and destination address, and if the Purolator Rate Estimate API has been enabled for the corresponding shipping zone. </strong></p></div>',
                                'id' => 'purolator_small_services'
                            ),
                          
                            'purolator_small_domastic_services' => array(
                                'name' => __('Canada to Canada', 'woocommerce-settings-purolator_small_quotes'),
                                'type' => 'checkbox',
                                'id' => 'purolator_small_domastic_services',
                                'class'=> 'dom_int_srvc_hdng'
                            ),

                            'purolator_small_int_services' => array(
                                'name' => __('Canada to U.S', 'woocommerce-settings-purolator_small_quotes'),
                                'type' => 'checkbox',
                                'id' => 'purolator_small_int_services',
                                'class'=> 'dom_int_srvc_hdng'
                            ),
                            'purolator_small_international_services' => array(
                                'name' => __('International Services', 'woocommerce-settings-purolator_small_quotes'),
                                'type' => 'checkbox',
                                'id' => 'purolator_small_international_services',
                                'class'=> 'dom_int_srvc_hdng'
                            ),
                            
                            'purolator_small_select_all_services' => array(
                                'name' => __('Select All', 'woocommerce-settings-purolator_small_quotes'),
                                'type' => 'checkbox',
                                'id' => 'purolator_small_ca_to_ca_select_all',
                                'class' => 'purolator_small_all_services',
                            ),

                            'purolator_small_select_all_int_services' => array(
                                'name' => __('Select All', 'woocommerce-settings-purolator_small_quotes'),
                                'type' => 'checkbox',
                                'id' => 'purolator_small_ca_to_us_select_all',
                                'class' => 'purolator_small_all_int_services',
                            ),
                            
                            'purolator_small_select_all_ww_services' => array(
                                'name' => __('Select All', 'woocommerce-settings-purolator_small_quotes'),
                                'type' => 'checkbox',
                                'id' => 'wc_settings_select_ww_all',
                                'class' => 'purolator_small_all_ww_services',
                            ),
                            
                            'purolator_small_express' => array(
                                'name' => __('Purolator Express', 'woocommerce-settings-purolator_small_quotes'),
                                'type' => 'checkbox',
                                'desc' => __('', 'woocommerce-settings-purolator_small_quotes'),
                                'id' => 'purolator_small_express',
                                'class' => 'purolator_small_quotes_services purolator_small_domestic_quote_service',
                            ),

                            'purolator_small_ground_us' => array(
                                'name' => __('Purolator Ground U.S', 'woocommerce-settings-purolator_small_quotes'),
                                'type' => 'checkbox',
                                'desc' => __('', 'woocommerce-settings-purolator_small_quotes'),
                                'id' => 'purolator_small_ground_us',
                                'class' => 'purolator_small_int_quotes_services',
                            ),
                                
                            'purolator_small_express_inter' => array(
                                'name' => __('Purolator Express International', 'woocommerce-settings-purolator_small_quotes'),
                                'type' => 'checkbox',
                                'desc' => __('', 'woocommerce-settings-purolator_small_quotes'),
                                'id' => 'purolator_small_express_inter',
                                'class' => 'purolator_small_ww_quotes_services',
                            ),

                            'purolator_small_express_9' => array(
                                'name' => __('Purolator Express 9AM', 'woocommerce-settings-purolator_small_quotes'),
                                'type' => 'checkbox',
                                'desc' => __('', 'woocommerce-settings-purolator_small_quotes'),
                                'id' => 'purolator_small_express_9',
                                'class' => 'purolator_small_quotes_services purolator_small_domestic_quote_service',
                            ),

                            'purolator_small_express_us' => array(
                                'name' => __('Purolator Express U.S', 'woocommerce-settings-purolator_small_quotes'),
                                'type' => 'checkbox',
                                'desc' => __('', 'woocommerce-settings-purolator_small_quotes'),
                                'id' => 'purolator_small_express_us',
                                'class' => 'purolator_small_int_quotes_services',
                            ),

                            'purolator_small_express_inter_12' => array(
                                'name' => __('Purolator Express International 12:00', 'woocommerce-settings-purolator_small_quotes'),
                                'type' => 'checkbox',
                                'desc' => __('', 'woocommerce-settings-purolator_small_quotes'),
                                'id' => 'purolator_small_express_inter_12',
                                'class' => 'purolator_small_ww_quotes_services',
                            ),

                            'purolator_small_express_10' => array(
                                'name' => __('Purolator Express 10:30AM', 'woocommerce-settings-purolator_small_quotes'),
                                'type' => 'checkbox',
                                'desc' => __('', 'woocommerce-settings-purolator_small_quotes'),
                                'id' => 'purolator_small_express_10',
                                'class' => 'purolator_small_quotes_services purolator_small_domestic_quote_service',
                            ),

                            'purolator_small_express_us_9am' => array(
                                'name' => __('Purolator Express U.S 9AM', 'woocommerce-settings-purolator_small_quotes'),
                                'type' => 'checkbox',
                                'desc' => __('', 'woocommerce-settings-purolator_small_quotes'),
                                'id' => 'purolator_small_express_us_9am',
                                'class' => 'purolator_small_int_quotes_services',
                            ),
                            
                            'purolator_small_2day_am' => array(
                                'name' => __('', 'woocommerce-settings-purolator_small_quotes'),
                                'type' => 'checkbox',
                                'desc' => __('', 'woocommerce-settings-purolator_small_quotes'),
                                'id' => 'purolator_small_2_day_AM',
                                'class' => 'purolator_small_quotes_services hide_checkbox',
                            ),

                            'purolator_small_ground' => array(
                                'name' => __('Purolator Ground', 'woocommerce-settings-purolator_small_quotes'),
                                'type' => 'checkbox',
                                'desc' => __('', 'woocommerce-settings-purolator_small_quotes'),
                                'id' => 'purolator_small_ground',
                                'class' => 'purolator_small_quotes_services purolator_small_domestic_quote_service',
                            ),
                                
                            'purolator_small_express_us_10am' => array(
                                'name' => __('Purolator Express U.S 10:30AM', 'woocommerce-settings-purolator_small_quotes'),
                                'type' => 'checkbox',
                                'desc' => __('', 'woocommerce-settings-purolator_small_quotes'),
                                'id' => 'purolator_small_express_us_10am',
                                'class' => 'purolator_small_int_quotes_services',
                            ),

                            'purolator_small_priority' => array(
                                'name' => __('', 'woocommerce-settings-purolator_small_quotes'),
                                'type' => 'checkbox',
                                'desc' => __('', 'woocommerce-settings-purolator_small_quotes'),
                                'id' => 'purolator_small_int_priority',
                                'class' => 'purolator_small_quotes_services hide_checkbox',
                            ),

                            'purolator_small_ground_90' => array(
                                'name' => __('Purolator Ground 9AM', 'woocommerce-settings-purolator_small_quotes'),
                                'type' => 'checkbox',
                                'desc' => __('', 'woocommerce-settings-purolator_small_quotes'),
                                'id' => 'purolator_small_ground_90',
                                'class' => 'purolator_small_quotes_services purolator_small_domestic_quote_service',
                            ),

                            'purolator_small_pr_dist' => array(
                                'name' => __('', 'woocommerce-settings-purolator_small_quotes'),
                                'type' => 'checkbox',
                                'desc' => __('', 'woocommerce-settings-purolator_small_quotes'),
                                'id' => 'purolator_small_int_priority_distribution',
                                'class' => 'purolator_small_quotes_services hide_checkbox',
                            ),

                            'purolator_small_fst_overnight' => array(
                                'name' => __('', 'woocommerce-settings-purolator_small_quotes'),
                                'type' => 'checkbox',
                                'desc' => __('', 'woocommerce-settings-purolator_small_quotes'),
                                'id' => 'purolator_small_first_overnight',
                                'class' => 'purolator_small_quotes_services hide_checkbox',
                            ),
                            

                            'purolator_small_ground_100' => array(
                                'name' => __('Purolator Ground 10:30AM', 'woocommerce-settings-purolator_small_quotes'),
                                'type' => 'checkbox',
                                'desc' => __('', 'woocommerce-settings-purolator_small_quotes'),
                                'id' => 'purolator_small_ground_100',
                                'class' => 'purolator_small_quotes_services purolator_small_domestic_quote_service',
                            ),

                            
                            'unable_retrieve_shipping_clear_wwe_small_packages' => array(
                                'name' => __('', 'woocommerce-settings-purolator_small_quotes'),
                                'type' => 'checkbox',
                                'desc' => __('', 'woocommerce-settings-purolator_small_quotes'),
                                'id' => 'purolator_small_quotes_services_empty',
                                'class' => 'purolator_small_quotes_services hide_checkbox',
                            ),
                            
                            
                            'purolator_small_int_distribution' => array(
                                'name' => __('', 'woocommerce-settings-purolator_small_quotes'),
                                'type' => 'checkbox',
                                'desc' => __('', 'woocommerce-settings-purolator_small_quotes'),
                                'id' => 'purolator_small_int_distribution_freight',
                                'class' => 'purolator_small_quotes_services hide_checkbox',
                            ),
                            
//                          Use my standard box sizes notification
                            'avaibility_box_sizing' => array(
                                'name' => __('Use my standard box sizes', 'woocommerce-settings-wwe_small_packages_quotes'),
                                'type' => 'text',
                                'class' => 'hidden',
                                'desc' => "Click <a target='_blank' href='https://eniture.com/woocommerce-standard-box-sizes/'>here</a> to add the box sizing module (<a target='_blank' href='https://eniture.com/woocommerce-standard-box-sizes/#documentation'>Learn more</a>)",
                                'id' => 'avaibility_box_sizing'
                            ),
                            
                            /*
                             * FedEx Residentail Delivery, Handeling Fee And Hazardous Fee
                             */

                                'purolator_small_hz_fee' => array(
                                    'name' => __('Hazardous Material Fee ', 'woocommerce-settings-purolator_small_quotes'),
                                    'type' => 'text',
                                    'desc' => '<span class="desc_text_style">Enter an amount, e.g 3.75 or Leave blank to disable.</span>',
                                    'id' => 'purolator_small_hazardous_fee'
                                ),

                                'purolator_small_hand_free' => array(
                                    'name' => __('Handling Fee / Markup ', 'woocommerce-settings-purolator_small_quotes'),
                                    'type' => 'text',
                                    'desc' => '<span class="desc_text_style">Amount excluding tax. Enter an amount, e.g 3.75, or a percentage, e.g, 5%. Leave blank to disable.</span>',
                                    'id' => 'purolator_small_hand_fee_mark_up'
                                ),
                                
                                'allow_other_plugins_purolator_small' => array(
                                    'name' => __('Allow other plugins to show quotes ', 'woocommerce-settings-purolator_small_quotes'),
                                    'type' => 'select',
                                    'default' => '3',
                                    'desc' => __('', 'woocommerce-settings-purolator_small_quotes'),
                                    'id' => 'allow_other_plugins_purolator_small',
                                    'options' => array(
                                        'no' => __('NO', 'NO'),
                                        'yes' => __('YES', 'YES')
                                    )
                                ),
                            
                                'unable_retrieve_shipping_clear_purolator_small' => array(
                                    'title' => __('', 'woocommerce'),
                                    'name' => __('', 'woocommerce-settings-purolator_small_quotes'),
                                    'desc' => '',
                                    'id' => 'wc_unable_retrieve_shipping_clear_purolator_small',
                                    'css' => '',
                                    'default' => '',
                                    'type' => 'title',
                                ),
                            
                            'unable_retrieve_shipping_purolator_small' => array(
                                    'name' => __('Checkout options if the plugin fails to return a rate ', 'woocommerce-settings-purolator_small_quotes'),
                                    'type' => 'title',
                                    'desc' => 'When the plugin is unable to retrieve shipping quotes and no other shipping options are provided by an alternative source:',
                                    'id' => 'wc_settings_unable_retrieve_shipping_purolator_small'
                                ),

                            
                                'pervent_checkout_proceed_purolator_small' => array(
                                    'name' => __('', 'woocommerce-settings-purolator_small_quotes'),
                                    'type' => 'radio',
                                    'options' => array(
                                        'allow' => __('' , 'woocommerce'),
                                        'prevent' => __('' , 'woocommerce'),

                                    ),
                                    'id' => 'wc_pervent_proceed_checkout_purolator_small',
                                ),
                            
                                'section_end_quote' => array(
                                    'type' => 'sectionend',
                                    'id' => 'wc_settings_quote_section_end'
                                )   
         
                        );
                        return $settings;
                    }
            }