<?php
/**
 * Warehouse Template
 * @package     Woocommerce Purolator Small
 * @author      <https://eniture.com/>
 * @copyright   Copyright (c) 2017, Eniture
 */
    if ( ! defined( 'ABSPATH' ) ) {
	exit; 
    }
    
/**
 * Get Warehouse List From Warehouse Table
 */
    
  global $wpdb;
  $warehous_list = $wpdb->get_results(
      "SELECT id, city, state, zip, country, location 
      FROM ".$wpdb->prefix."warehouse WHERE location = 'warehouse'"
  );
?>
<script type="text/javascript">
    jQuery( document ).ready(function() {
        window.location.href = jQuery('.close').attr( 'href' );
        
        /*
         * Set Empty Values On Add Warehouse Click
         */
        
        jQuery( '.hide_val' ).click( function () {
            jQuery( '.city_input' ).show();
            jQuery( '.not_allowed, .city_select, .already_exist, .warehouse_invalid_input_message, .wrng_credential, .purolator_small_zip_validation_err, .purolator_small_city_validation_err, .purolator_small_state_validation_err, .purolator_small_country_validation_err' ).hide();
            jQuery( '#edit_form_id, #purolator_small_origin_zip, #purolator_small_origin_city, #purolator_small_origin_state, #purolator_small_origin_country' ).val( '' );
        });
      
        /*
         * Set Focus To First Input
         */
      
        jQuery( '.purolator_small_add_warehouse_btn' ).click( function () {
            setTimeout( function () {
              if( jQuery( '.purolator_small_add_warehouse_popup' ).is( ':visible' ) ) {
                jQuery( '.purolator_small_add_warehouse_input > input' ).eq( 0 ).focus();
              }
            }, 500 );
        });
        
        /*
         * Get Address Using Zip Code From API
         */
        
        jQuery( "#purolator_small_origin_zip" ).on( 'change', function () {
        if ( jQuery( "#purolator_small_origin_zip" ).val() == '' ) {
            return false;
        }
        
        jQuery( '.city_select_css, #purolator_small_origin_city, #purolator_small_origin_state, #purolator_small_origin_country' ).addClass( 'purolator_small_test_conn_prosessing' );
        
        var postForm = {
            'action'     : 'purolator_small_get_address',
            'origin_zip' : jQuery('#purolator_small_origin_zip').val(),
        };

        jQuery.ajax({
            type: 'POST', 
            url: ajaxurl, 
            data: postForm, 
            dataType: 'json',
            beforeSend: function () 
            {
                jQuery( '.purolator_small_zip_validation_err, .purolator_small_city_validation_err, .purolator_small_state_validation_err, .purolator_small_country_validation_err' ).hide();
            },
            success: function ( data ) 
            {
                if( data ){
                    if( data.state && data.country == 'CA' ) {
                        if ( data.postcode_localities == 1 ) {
                            jQuery( '.city_select' ).show();
                            jQuery( '#actname' ).replaceWith( data.city_option );
                            jQuery( '.purolator_small_multi_state' ).replaceWith( data.city_option );
                            jQuery( '#purolator_small_origin_state' ).val( data.state );
                            jQuery( '#purolator_small_origin_country' ).val( data.country );
                            jQuery( '.city-multiselect' ).change( function(){
                                fxSmWhSetCity(this);
                            });
                            jQuery( '#purolator_small_origin_city' ).val( data.first_city );
                            jQuery( '.city_select_css, #purolator_small_origin_city, #purolator_small_origin_state, #purolator_small_origin_country' ).removeClass( 'purolator_small_test_conn_prosessing' );                            
                            jQuery( '.city_input' ).hide();
                        }else{
                            jQuery( '.city_input' ).show();
                            jQuery( '#_city' ).removeAttr('value');
                            jQuery( '.city_select' ).hide();
                            jQuery( '#purolator_small_origin_city' ).val( data.city );
                            jQuery( '#purolator_small_origin_state' ).val( data.state );
                            jQuery( '#purolator_small_origin_country' ).val( data.country );
                            jQuery( '#purolator_small_origin_city, #purolator_small_origin_state, #purolator_small_origin_country' ).removeClass( 'purolator_small_test_conn_prosessing' );
                        }
                    }else if( data.result === 'false' ){
                        jQuery( '#purolator_small_origin_city, #purolator_small_origin_state, #purolator_small_origin_country' ).removeClass( 'purolator_small_test_conn_prosessing' );   
                    }else if( data.apiResp === 'apiErr' ){
                        jQuery( '.wrng_credential' ).show( 'slow' );
                        jQuery( '#purolator_small_origin_city, #purolator_small_origin_state, #purolator_small_origin_country' ).removeClass( 'purolator_small_test_conn_prosessing' ); 
                        setTimeout( function () {
                            jQuery( '.wrng_credential' ).hide( 'slow' );
                        }, 5000 );
                    }else{
                        jQuery( '.not_allowed' ).show( 'slow' );
                        jQuery( '#purolator_small_origin_city, #purolator_small_origin_state, #purolator_small_origin_country' ).removeClass( 'purolator_small_test_conn_prosessing' );  
                        setTimeout( function () {
                            jQuery( '.not_allowed' ).hide( 'slow' );
                        }, 5000 );
                    }
                }
            },
        }); return false;
        });
    });
  
    function fxSmWhSetCity( e ){
    console.log(e);
        var city = jQuery( e ).val();
        jQuery( '#purolator_small_origin_city' ).val( city );
    }
    
    jQuery( function() {
        jQuery( 'input.alphaonly' ).keyup( function () {
            if ( this.value.match( /[^a-zA-Z ]/g ) ) {
                this.value = this.value.replace( /[^a-zA-Z ]/g, '' );
            }
        });
    });
</script>
    
    <!--
        Warehouse Table HTML
    -->
    <div class="purolator_small_warehouse_section">
        <br>
        <div class="purolator_small_wh_message">
            <p>
                <strong>
                    Purolator restricts origins for new Production Keys to the registered address. If you want to define more than one warehouse or drop ship location, you will need to contact Purolator and have the sender's address restriction removed from your Production Key.
                </strong>
            </p>
        </div>
        
        <h1>
            Warehouses
        </h1>
    
        <br>
    
        <a href="#purolator_small_add_warehouse_btn" title="Add Warehouse" class="purolator_small_add_warehouse_btn hide_val" name="avc">
            Add
        </a>

        <br>
    
        <div class="warehouse_text">
            <p>
                Warehouses that inventory all products not otherwise identified as drop shipped items. The warehouse with the lowest shipping cost to the destination is used for quoting purposes.
            </p>
        </div>
    
        <div id="message" class="updated inline warehouse_deleted">
            <p>
                <strong>
                    Success! Warehouse deleted successfully.
                </strong>
            </p>
        </div>
    
        <div id="message" class="updated inline warehouse_created">
            <p>
                <strong>
                    Success! New warehouse added successfully.
                </strong>
            </p>
        </div>
    
        <div id="message" class="updated inline warehouse_updated">
            <p>
                <strong>
                    Success! Warehouse updated successfully.
                </strong>
            </p>
        </div>

        <table class="purolator_small_warehouse_list" id="append_warehouse">
            <thead>
                <tr>
                    <th class="purolator_small_warehouse_list_heading">
                        City
                    </th>

                    <th class="purolator_small_warehouse_list_heading">
                        State
                    </th>

                    <th class="purolator_small_warehouse_list_heading">
                        Zip
                    </th>

                    <th class="purolator_small_warehouse_list_heading">
                        Country
                    </th>

                    <th class="purolator_small_warehouse_list_heading">
                        Action
                    </th>
                </tr>
            </thead>
            <tbody>
            <?php
            if ( count($warehous_list ) > 0 ) {
                foreach ( $warehous_list as $list ) 
                {
            ?>
                <tr id="row_<?php echo ( isset( $list->id ) ) ? esc_attr( $list->id ) : ''; ?>" data-id="<?php echo ( isset( $list->id ) ) ? esc_attr( $list->id ) : ''; ?>">
                    <td class="purolator_small_warehouse_list_data">
                        <?php echo ( isset( $list->city ) ) ? esc_attr( $list->city ) : ''; ?>
                    </td>

                    <td class="purolator_small_warehouse_list_data">
                        <?php echo ( isset( $list->state ) ) ? esc_attr( $list->state ) : ''; ?>
                    </td>

                    <td class="purolator_small_warehouse_list_data">
                        <?php echo ( isset( $list->zip ) ) ? esc_attr( $list->zip ) : ''; ?>
                    </td>

                    <td class="purolator_small_warehouse_list_data">
                        <?php echo ( isset( $list->country ) ) ? esc_attr( $list->country ) : ''; ?>
                    </td>

                    <td class="purolator_small_warehouse_list_data">
                        <a href="javascript(0)" onclick="return purolator_small_edit_warehouse(<?php echo ( isset( $list->id ) ) ? esc_attr( $list->id ) : ''; ?>);"><img src="<?php echo plugins_url(); ?>/small-package-quotes-purolator-edition/asset/edit.png" title="Edit"></a>
                        <a href="javascript(0)" onclick="return purolator_small_delete_current_warehouse(<?php echo ( isset( $list->id ) ) ? esc_attr( $list->id ) : ''; ?>);"><img src="<?php echo plugins_url(); ?>/small-package-quotes-purolator-edition/asset/delete.png" title="Delete"></a>
                    </td>
                </tr>
            <?php } 
            }else{ ?>
                <tr class="new_warehouse_add" data-id=0></tr>
            <?php } ?>
            </tbody>
        </table>

    <!-- 
        Add New Warehouse Popup 
    -->
        <div id="purolator_small_add_warehouse_btn" class="purolator_small_warehouse_overlay">
            <div class="purolator_small_add_warehouse_popup">
                <h2 class="warehouse_heading">
                    Warehouse
                </h2>

                <a class="close" href="#">
                    &times;
                </a>

                <div class="content">
                    <div class="already_exist">
                        <strong>
                            Error!
                        </strong> Zip code already exists.
                    </div>
                    <div class="warehouse_invalid_input_message">
                        <strong>
                            Error!
                        </strong> Invalid input data.
                    </div>

                    <div class="not_allowed">
                        <strong>
                            Error!
                        </strong> Please enter CA zip code.
                    </div>

                    <div class="wrng_credential">
                        <strong>
                            Error!
                        </strong> Please verify credentials at connection settings panel.
                    </div>

                    <form method="post">
                        <input type="hidden" name="edit_form_id" value="" id="edit_form_id">

                        <div class="purolator_small_add_warehouse_input">
                            <label for="purolator_small_warehouse_zip">
                                Zip
                            </label>
                            <input type="text" title="Zip" value="" name="purolator_small_origin_zip" placeholder="30214" id="purolator_small_origin_zip">
                        </div>

                        <div class="purolator_small_add_warehouse_input city_input">
                            <label for="purolator_small_warehouse_city">
                                City
                            </label>
                            <input type="text" value="" title="City" name="purolator_small_origin_city" placeholder="Fayetteville" id="purolator_small_origin_city">
                        </div>

                        <div class="purolator_small_add_warehouse_input city_select" title="City" style="display:none;">
                            <label for="purolator_small_warehouse_city">
                                City
                            </label>
                            <select id="actname"></select>
                        </div>

                        <div class="purolator_small_add_warehouse_input">
                            <label for="purolator_small_warehouse_state">
                                State
                            </label>
                            <input type="text" value="" title="State" class="alphaonly" maxlength="2" name="purolator_small_origin_state" placeholder="GA" id="purolator_small_origin_state">
                        </div>

                        <div class="purolator_small_add_warehouse_input">
                            <label for="purolator_small_warehouse_country">
                                Country
                            </label>
                            <input type="text" title="Country" class="alphaonly" maxlength="2" name="purolator_small_origin_country" value="" placeholder="US" id="purolator_small_origin_country">
                            <input type="hidden" name="purolator_small_location" value="warehouse" id="purolator_small_location">
                        </div>

                        <div class="purolator_small_add_warehouse_input">
                            <input type="submit" name="purolator_small_submit_warehouse" value="Save" class="save_warehouse_form" onclick="return purolator_small_save_warehouse();">
                        </div>
                    </form>
                </div>
            </div>
        </div>

